<?php /*
Plugin Name: RV Akismet
Version: 1.7.b
Description: Uses Akismet online service to check comments agains spam
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=192
Author: rvelices
Author URI: http://www.modusoptimus.com
*/

add_event_handler('user_comment_check', 'akismet_user_comment_check',
  EVENT_HANDLER_PRIORITY_NEUTRAL+10, 2);

add_event_handler('get_admin_plugin_menu_links', 'akismet_plugin_admin_menu' );

function akismet_plugin_admin_menu($menu)
{
  global $page,$conf;
  if ( empty($conf['akismet_api_key']) and in_array($page['page'], array('intro','plugins')) )
    $page['errors'][] = 'You need to define the Akismet api key';

  $admin_url = get_admin_plugin_menu_link(dirname(__FILE__).'/admin.php');
  array_push($menu,
      array(
        'NAME' => 'Akismet',
        'URL' => $admin_url
      )
    );
  return $menu;
}


function akismet_user_comment_check($action, $comment)
{
  global $conf;
  if ('reject'==$action or $conf['akismet_spam_action']==$action)
    return $action; // already rejecting
  if ( empty($conf['akismet_api_key']) )
    return $action; // need to config it

  include_once( dirname(__FILE__).'/akismet.class.php' );

  set_make_full_url();
  $url = duplicate_picture_url();
  unset_make_full_url();
  $aki_comm = array(
    'author' => $comment['author'],
    'body' => $comment['content'],
    'permalink' => $url,
    'referrer' => isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '',
  );

  $akismet = new Akismet($conf['gallery_url'], $conf['akismet_api_key'], $aki_comm);

  if( !$akismet->errorsExist() )
  {
    $counters = explode('/', $conf['akismet_counters']);
    if ( $akismet->isSpam() )
    {
      $action = $conf['akismet_spam_action'];
      $counters[0]++;
    }
    $counters[1]++;
    $conf['akismet_counters'] = implode('/', $counters);
    $query = 'UPDATE '.CONFIG_TABLE.' SET value="'.$conf['akismet_counters'].'" WHERE param="akismet_counters" LIMIT 1';
    pwg_query($query);
  }
  elseif (is_admin())
    var_export( $akismet->getErrors() );
  return $action;
}

?>